package betterwithmods.common.blocks.mechanical;

import betterwithmods.api.block.IAxle;
import betterwithmods.api.block.IMechanicalBlock;
import betterwithmods.client.BWCreativeTabs;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWOreDictionary;
import betterwithmods.common.blocks.BWMBlock;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.util.DirUtils;
import betterwithmods.util.MechanicalUtil;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyInteger;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.resources.I18n;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.oredict.OreDictionary;

import javax.annotation.Nullable;
import java.util.List;
import java.util.Random;

public class BlockBrokenGearbox extends BWMBlock implements IMechanicalBlock {
    public static final PropertyInteger STAGE = PropertyInteger.func_177719_a("repair", 0, 1);
    public BlockBrokenGearbox() {
        super (Material.field_151575_d);
        this.func_149711_c(2.0F);
        this.func_180632_j(func_176223_P().func_177226_a(DirUtils.FACING, EnumFacing.UP).func_177226_a(STAGE, 0));
        this.func_149647_a(BWCreativeTabs.BWTAB);
        func_149675_a(true);
    }

    @Override
    public void func_190948_a(ItemStack stack, @Nullable World player, List<String> tooltip, ITooltipFlag advanced) {
        tooltip.add(I18n.func_135052_a("tooltip.broken_gearbox.name"));
        super.func_190948_a(stack, player, tooltip, advanced);
    }

    @Override
    public void func_180645_a(World worldIn, BlockPos pos, IBlockState state, Random rand) {
        if (MechanicalUtil.isBlockPoweredByAxle(worldIn, pos, this)) {
            for (int i = 0; i < 5; i++) {
                float flX = pos.func_177958_n() + rand.nextFloat();
                float flY = pos.func_177956_o() + rand.nextFloat() * 0.5F + 1.0F;
                float flZ = pos.func_177952_p() + rand.nextFloat();

                worldIn.func_175688_a(EnumParticleTypes.SMOKE_LARGE, flX, flY, flZ, 0.0D, 0.0D, 0.0D);
            }
            worldIn.func_184133_a(null, pos, SoundEvents.field_187927_ha, SoundCategory.BLOCKS, 1.0F, worldIn.field_73012_v.nextFloat() * 0.1F + 0.45F);
        }
        super.func_180645_a(worldIn, pos, state, rand);
    }


    @Override
    public IBlockState func_180642_a(World world, BlockPos pos, EnumFacing side, float flX, float flY, float flZ, int meta, EntityLivingBase placer) {
        IBlockState state = super.func_180642_a(world, pos, side, flX, flY, flZ, meta, placer);
        return state.func_177226_a(DirUtils.FACING, side.func_176734_d());
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity, ItemStack stack) {
        EnumFacing facing = DirUtils.convertEntityOrientationToFacing(entity, EnumFacing.NORTH);
        world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(DirUtils.FACING, facing));
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        ItemStack hold = player.func_184586_b(hand);
        if (!hold.func_190926_b()) {
            if (BWOreDictionary.listContains(hold, OreDictionary.getOres("gearWood"))) {
                if (world.field_72995_K)
                    return true;
                else {
                    advanceStage(world, pos, state);
                    if (!player.field_71075_bZ.field_75098_d)
                        hold.func_190918_g(1);
                    return true;
                }
            }
        }
        return false;
    }

    private void advanceStage(World world, BlockPos pos, IBlockState state) {
        if (state.func_177229_b(STAGE) == 0)
            world.func_175656_a(pos, state.func_177226_a(STAGE, 1));
        else
            world.func_175656_a(pos, BWMBlocks.GEARBOX.func_176223_P().func_177226_a(DirUtils.FACING, state.func_177229_b(DirUtils.FACING)).func_177226_a(BlockGearbox.ISACTIVE, false));
    }

    @Override
    public List<ItemStack> getDrops(IBlockAccess world, BlockPos pos, IBlockState state, int fortune) {
        List<ItemStack> list = super.getDrops(world, pos, state, fortune);
        if (state.func_177229_b(STAGE) == 1)
            list.add(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.GEAR));
        return list;
    }

    private boolean isAxle(IBlockAccess world, BlockPos origin, EnumFacing facing) {
        BlockPos pos = origin.func_177972_a(facing);
        Block block = world.func_180495_p(pos).func_177230_c();
        return block instanceof IAxle && ((IAxle) block).isAxleOrientedToFacing(world, pos, facing.func_176734_d());
    }

    @Override
    public IBlockState func_176221_a(IBlockState state, IBlockAccess world, BlockPos pos) {
        boolean[] dirs = new boolean[6];
        for (int i = 0; i < 6; i++) {
            EnumFacing facing = EnumFacing.func_82600_a(i);
            dirs[i] = isAxle(world, pos, facing) && state.func_177229_b(DirUtils.FACING) != facing;
        }
        return state.func_177226_a(DirUtils.DOWN, dirs[0])
                .func_177226_a(DirUtils.UP, dirs[1])
                .func_177226_a(DirUtils.NORTH, dirs[2])
                .func_177226_a(DirUtils.SOUTH, dirs[3])
                .func_177226_a(DirUtils.WEST, dirs[4])
                .func_177226_a(DirUtils.EAST, dirs[5]);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        int meta = state.func_177229_b(STAGE) == 1 ? 8 : 0;
        meta += state.func_177229_b(DirUtils.FACING).func_176745_a();
        return meta;
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        int stage = 0;
        if (meta > 7) {
            stage = 1;
            meta -= 8;
        }
        return this.func_176223_P().func_177226_a(STAGE, stage).func_177226_a(DirUtils.FACING, EnumFacing.func_82600_a(meta));
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, DirUtils.FACING, STAGE, DirUtils.UP, DirUtils.DOWN, DirUtils.NORTH, DirUtils.SOUTH, DirUtils.WEST, DirUtils.EAST);
    }

    @Override
    public boolean canOutputMechanicalPower() {
        return false;
    }

    @Override
    public boolean canInputMechanicalPower() {
        return false;
    }

    @Override
    public boolean isInputtingMechPower(World world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean isOutputtingMechPower(World world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean canInputPowerToSide(IBlockAccess world, BlockPos pos, EnumFacing dir) {
        EnumFacing facing = world.func_180495_p(pos).func_177229_b(DirUtils.FACING);
        return dir == facing;
    }

    @Override
    public void overpower(World world, BlockPos pos) {

    }

    @Override
    public boolean isMechanicalOn(IBlockAccess world, BlockPos pos) {
        return false;
    }

    @Override
    public void setMechanicalOn(World world, BlockPos pos, boolean isOn) {

    }

    @Override
    public boolean isMechanicalOnFromState(IBlockState state) {
        return false;
    }
}
