package betterwithmods.common.blocks.mechanical;

import betterwithmods.BWMod;
import betterwithmods.api.block.IMechanicalBlock;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BWMBlock;
import betterwithmods.common.blocks.BlockAesthetic;
import betterwithmods.common.blocks.mini.IDamageDropped;
import betterwithmods.common.damagesource.BWDamageSource;
import betterwithmods.common.registry.blockmeta.managers.SawManager;
import betterwithmods.event.FakePlayerHandler;
import betterwithmods.module.gameplay.MechanicalBreakage;
import betterwithmods.util.DirUtils;
import betterwithmods.util.InvUtils;
import betterwithmods.util.MechanicalUtil;
import net.minecraft.block.Block;
import net.minecraft.block.BlockLiquid;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.*;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraftforge.fluids.IFluidBlock;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.List;
import java.util.Random;

public class BlockSaw extends BWMBlock implements IMechanicalBlock {
    public static final PropertyBool ISACTIVE = PropertyBool.func_177716_a("isactive");
    private static final float HEIGHT = 0.71875F;
    private static final AxisAlignedBB D_AABB = new AxisAlignedBB(0.0F, 1.0F - HEIGHT, 0.0F, 1.0F, 1.0F, 1.0F);
    private static final AxisAlignedBB U_AABB = new AxisAlignedBB(0.0F, 0.0F, 0.0F, 1.0F, HEIGHT, 1.0F);
    private static final AxisAlignedBB N_AABB = new AxisAlignedBB(0.0F, 0.0F, 1.0F - HEIGHT, 1.0F, 1.0F, 1.0F);
    private static final AxisAlignedBB S_AABB = new AxisAlignedBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, HEIGHT);
    private static final AxisAlignedBB W_AABB = new AxisAlignedBB(1.0F - HEIGHT, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    private static final AxisAlignedBB E_AABB = new AxisAlignedBB(0.0F, 0.0F, 0.0F, HEIGHT, 1.0F, 1.0F);

    public BlockSaw() {
        super(Material.field_151575_d);
        this.func_149711_c(2.0F);
        this.func_149672_a(SoundType.field_185848_a);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(DirUtils.FACING, EnumFacing.UP));
    }

    @Override
    public int func_149738_a(World world) {
        return 10;
    }

    @Override
    public IBlockState getStateForPlacement(World world, BlockPos pos, EnumFacing facing, float flX, float flY, float flZ, int meta, EntityLivingBase placer, EnumHand hand) {
        IBlockState state = super.getStateForPlacement(world, pos, facing, flX, flY, flZ, meta, placer, hand);
        return setFacingInBlock(state, DirUtils.getOpposite(facing));
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity, ItemStack stack) {
        EnumFacing facing = DirUtils.convertEntityOrientationToFacing(entity, EnumFacing.NORTH);
        world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(DirUtils.FACING, facing));
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state) {
        super.func_176213_c(world, pos, state);
        world.func_180497_b(pos, this, func_149738_a(world), 5);
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess world, BlockPos pos) {
        state = state.func_185899_b(world, pos);
        EnumFacing facing = getFacingFromBlockState(state);
        switch (facing) {
            case DOWN:
                return D_AABB;
            case UP:
                return U_AABB;
            case NORTH:
                return N_AABB;
            case SOUTH:
                return S_AABB;
            case WEST:
                return W_AABB;
            case EAST:
            default:
                return E_AABB;
        }
    }

    @Override
    public void func_189540_a(IBlockState state, World world, BlockPos pos, Block block, BlockPos other) {
        if (block == BWMBlocks.AXLE || block == BWMBlocks.HAND_CRANK)
            world.func_180497_b(pos, this, func_149738_a(world), 5);
        else
            world.func_180497_b(pos, this, func_149738_a(world) + world.field_73012_v.nextInt(6), 5);
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        boolean powered = isInputtingMechPower(world, pos);
        boolean isOn = isBlockOn(world, pos);

        if (isOn != powered) {
            emitSawParticles(world, pos, rand);
            setMechanicalOn(world, pos, powered);
            if (powered) {
                world.func_180497_b(pos, this, func_149738_a(world) + rand.nextInt(6), 5);
                world.func_184133_a(null, pos, SoundEvents.field_187782_ds, SoundCategory.BLOCKS, 1.0F + rand.nextFloat() * 0.1F, 1.5F + rand.nextFloat() * 0.1F);
            } else
                world.func_184133_a(null, pos, SoundEvents.field_187782_ds, SoundCategory.BLOCKS, 1.0F + rand.nextFloat() * 0.1F, 0.75F + rand.nextFloat() * 0.1F);
        } else if (powered) {
            sawBlockInFront(world, pos, rand);
            world.func_180497_b(pos, this, func_149738_a(world) + rand.nextInt(6), 5);
        }
    }

    @Override
    public void func_180634_a(World world, BlockPos pos, IBlockState state, Entity entity) {
        if (isMechanicalOn(world, pos) && entity instanceof EntityLivingBase) {
            EnumFacing dir = getFacing(world, pos);

            DamageSource source = BWDamageSource.saw;
            int damage = 4;
            boolean unobstructed = true;
            for (int i = 0; i < 3; i++) {
                BlockPos pos2 = new BlockPos(pos.func_177958_n(), pos.func_177956_o() - i, pos.func_177952_p()).func_177972_a(dir);
                Block block = world.func_180495_p(pos2).func_177230_c();
                IBlockState blockState = world.func_180495_p(pos2);
                if (block == BWMBlocks.AESTHETIC && blockState.func_177229_b(BlockAesthetic.TYPE).getMeta() < 2) {
                    source = BWDamageSource.choppingBlock;
                    damage *= 3;
                    if (blockState.func_177229_b(BlockAesthetic.TYPE).getMeta() == 0 && unobstructed)
                        world.func_175656_a(pos2, BWMBlocks.AESTHETIC.func_176223_P().func_177226_a(BlockAesthetic.TYPE, BlockAesthetic.EnumType.CHOPBLOCKBLOOD));
                    break;
                } else if (!world.func_175623_d(pos2) && !(block instanceof BlockLiquid) && !(block instanceof IFluidBlock))
                    break;
                else if (!world.func_175623_d(pos2))
                    unobstructed = false;
            }
            if (entity instanceof EntityMob && ((EntityLivingBase) entity).func_110143_aJ() <= damage) {
                ((EntityLivingBase) entity).field_70718_bc = 60;
                if (world instanceof WorldServer)
                    performLastHit(entity, damage);
            } else if (entity.func_70097_a(source, damage)) {
                ((EntityLivingBase) entity).field_70718_bc = 60;
                world.func_184133_a(null, pos, SoundEvents.field_187782_ds, SoundCategory.BLOCKS, 1.0F + world.field_73012_v.nextFloat() * 0.1F, 1.5F + world.field_73012_v.nextFloat() * 0.1F);
            }
        }
    }

    private void performLastHit(Entity entity, float damage) {
        entity.func_70097_a(DamageSource.func_76365_a(FakePlayerHandler.player), damage);
    }

    @Override
    public boolean isSideSolid(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing side) {
        return side != getFacingFromBlockState(state);
    }

    public EnumFacing getFacing(IBlockAccess world, BlockPos pos) {
        return getFacingFromBlockState(world.func_180495_p(pos));
    }

    @Override
    public EnumFacing getFacingFromBlockState(IBlockState state) {
        return state.func_177229_b(DirUtils.FACING);
    }

    @Override
    public IBlockState setFacingInBlock(IBlockState state, EnumFacing facing) {
        return state.func_177226_a(DirUtils.FACING, facing);
    }

    @Override
    public boolean canRotateOnTurntable(IBlockAccess world, BlockPos pos) {
        return getFacing(world, pos) != EnumFacing.DOWN && getFacing(world, pos) != EnumFacing.UP;
    }

    @Override
    public boolean canRotateVertically(IBlockAccess world, BlockPos pos) {
        return canRotateOnTurntable(world, pos);
    }

    @Override
    public void rotateAroundYAxis(World world, BlockPos pos, boolean reverse) {
        if (DirUtils.rotateAroundY(this, world, pos, reverse)) {
            world.func_180497_b(pos, this, func_149738_a(world), 5);
            MechanicalUtil.destoryHorizontalAxles(world, pos);
        }
    }

    public boolean isBlockOn(IBlockAccess world, BlockPos pos) {
        return world.func_180495_p(pos).func_177229_b(ISACTIVE);
    }

    @Override
    public boolean canOutputMechanicalPower() {
        return false;
    }

    @Override
    public boolean canInputMechanicalPower() {
        return true;
    }

    @Override
    public boolean isInputtingMechPower(World world, BlockPos pos) {
        return MechanicalUtil.isBlockPoweredByAxle(world, pos, this);
    }

    @Override
    public boolean isOutputtingMechPower(World world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean canInputPowerToSide(IBlockAccess world, BlockPos pos,
                                       EnumFacing dir) {
        return dir != getFacing(world, pos);
    }

    @Override
    public void overpower(World world, BlockPos pos) {
        breakSaw(world, pos);
    }

    public void breakSaw(World world, BlockPos pos) {
        if (MechanicalBreakage.saw)
            InvUtils.ejectBrokenItems(world, pos, new ResourceLocation(BWMod.MODID, "block/saw"));
        /*
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 1, 0));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(Blocks.PLANKS));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 3, 22));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(Items.IRON_INGOT, 2, 0));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 4, 30));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 3, 8));
        */
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F, world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    @Override
    public boolean isMechanicalOn(IBlockAccess world, BlockPos pos) {
        return isBlockOn(world, pos);
    }

    @Override
    public void setMechanicalOn(World world, BlockPos pos, boolean isOn) {
        boolean active = world.func_180495_p(pos).func_177229_b(ISACTIVE);
        if (isOn != active)
            world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(ISACTIVE, isOn));
    }

    public void emitSawParticles(World world, BlockPos pos, Random rand) {
        EnumFacing facing = getFacing(world, pos);
        float xPos = pos.func_177958_n();
        float yPos = pos.func_177956_o();
        float zPos = pos.func_177952_p();
        float xExtent = 0.0F;
        float zExtent = 0.0F;

        switch (facing) {
            case DOWN:
                xPos += 0.5F;
                zPos += 0.5F;
                xExtent = 1.0F;
                break;
            case UP:
                xPos += 0.5F;
                zPos += 0.5F;
                yPos += 1.0F;
                xExtent = 1.0F;
                break;
            case NORTH:
                xPos += 0.5F;
                yPos += 0.5F;
                xExtent = 1.0F;
                break;
            case SOUTH:
                xPos += 0.5F;
                yPos += 0.5F;
                zPos += 1.0F;
                xExtent = 1.0F;
                break;
            case WEST:
                yPos += 0.5F;
                zPos += 0.5F;
                zExtent = 1.0F;
                break;
            default:
                yPos += 0.5F;
                zPos += 0.5F;
                xPos += 1.0F;
                zExtent = 1.0F;
        }

        for (int i = 0; i < 5; i++) {
            float smokeX = xPos + (rand.nextFloat() - 0.5F) * xExtent;
            float smokeY = yPos + rand.nextFloat() * 0.1F;
            float smokeZ = zPos + (rand.nextFloat() - 0.5F) * zExtent;
            world.func_175688_a(EnumParticleTypes.SMOKE_NORMAL, smokeX, smokeY, smokeZ, 0.0D, 0.0D, 0.0D);
        }
    }

    private void sawBlockInFront(World world, BlockPos pos, Random rand) {
        if (world.field_72995_K || !(world instanceof WorldServer))
            return;
        BlockPos pos2 = pos.func_177972_a(getFacing(world, pos));
        if(world.func_175623_d(pos2))
            return;
        IBlockState state = world.func_180495_p(pos2);
        Block block = state.func_177230_c();
        int harvestMeta = block.func_180651_a(state);
        if(block instanceof IDamageDropped)
            harvestMeta = ((IDamageDropped) block).damageDropped(state,world,pos2);

        if (SawManager.INSTANCE.contains(block, harvestMeta)) {
            List<ItemStack> products = SawManager.INSTANCE.getProducts(block, harvestMeta);
            world.func_175698_g(pos2);
            if (!products.isEmpty())
                InvUtils.ejectStackWithOffset(world, pos2, products);
            world.func_184133_a(null, pos2, SoundEvents.field_187782_ds, SoundCategory.BLOCKS, 1.5F + rand.nextFloat() * 0.1F, 2.0F + rand.nextFloat() * 0.1F);
        }
    }

    @Override
    public boolean isMechanicalOnFromState(IBlockState state) {
        return state.func_177229_b(ISACTIVE);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_180655_c(IBlockState state, World world, BlockPos pos, Random rand) {
        if (isMechanicalOn(world, pos)) {
            emitSawParticles(world, pos, rand);

            List<EntityLivingBase> entities = world.func_72872_a(EntityLivingBase.class, new AxisAlignedBB(pos, pos.func_177982_a(1, 1, 1)));
            if (!entities.isEmpty() && entities.size() > 0)
                emitBloodParticles(world, pos);
        }
    }

    private void emitBloodParticles(World world, BlockPos pos) {
        EnumFacing facing = getFacing(world, pos);
        float xPos = pos.func_177958_n();
        float yPos = pos.func_177956_o();
        float zPos = pos.func_177952_p();
        float xExtent = 0.0F;
        float zExtent = 0.0F;

        switch (facing) {
            case DOWN:
                xPos += 0.5F;
                zPos += 0.5F;
                xExtent = 1.0F;
                break;
            case UP:
                xPos += 0.5F;
                zPos += 0.5F;
                yPos += 1.0F;
                xExtent = 1.0F;
                break;
            case NORTH:
                xPos += 0.5F;
                yPos += 0.5F;
                xExtent = 1.0F;
                break;
            case SOUTH:
                xPos += 0.5F;
                yPos += 0.5F;
                zPos += 1.0F;
                xExtent = 1.0F;
                break;
            case WEST:
                yPos += 0.5F;
                zPos += 0.5F;
                zExtent = 1.0F;
                break;
            default:
                yPos += 0.5F;
                zPos += 0.5F;
                xPos += 1.0F;
                zExtent = 1.0F;
        }

        for (int i = 0; i < 20; i++) {
            float smokeX = xPos + (world.field_73012_v.nextFloat() - 0.5F) * xExtent;
            float smokeY = yPos + world.field_73012_v.nextFloat() * 0.1F;
            float smokeZ = zPos + (world.field_73012_v.nextFloat() - 0.5F) * zExtent;
            world.func_175688_a(EnumParticleTypes.REDSTONE, smokeX, smokeY, smokeZ, 0.0D, 0.0D, 0.0D);
        }
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        boolean isActive = meta > 7;
        if (isActive)
            meta -= 8;
        EnumFacing facing = EnumFacing.func_82600_a(meta);
        return this.func_176223_P().func_177226_a(ISACTIVE, isActive).func_177226_a(DirUtils.FACING, facing);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        int meta = state.func_177229_b(ISACTIVE) ? 8 : 0;
        meta += state.func_177229_b(DirUtils.FACING).ordinal();
        return meta;
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, ISACTIVE, DirUtils.FACING);
    }
}
